﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace LAB11
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        //Globális változó
        Random randi = new Random();

        private void Form1_Load(object sender, EventArgs e)
        {
            Text = "Függvények II.";
            button1.Text = "Gyakoriság";
            button2.Text = "Lotto";
            checkBox1.Text = "Sorrendbe";
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int[] dolgozatok = jegyek(100);
            int[] gyakorisagok = gyakorisag(dolgozatok);
            torol();
            kiir(gyakorisagok);
            listBox1.Items.Add($"Az átlag: {atlag_jegybol(dolgozatok):F2}");
            listBox1.Items.Add($"Az átlag: {atlag_gyakorisagbol(gyakorisagok):F2}");
        }

        int[] jegyek(int meret)
        {
            int[] dolgozatok = new int[meret];
            for (int i = 0; i < dolgozatok.Length; i++)
                dolgozatok[i] = randi.Next(6); //0..5
            return dolgozatok;
        }

        int[] gyakorisag(int[] t)
        {
            int[] gyakorisag = new int[6];     //0..5
            for (int i = 0; i < t.Length; i++)
                gyakorisag[t[i]]++;
            return gyakorisag;
        }

        void kiir(int[] t)
        {
            for(int i=0; i<t.Length; i++)
            {
                listBox1.Items.Add(t[i]);
            }
        }

        void torol()
        {
            listBox1.Items.Clear();
        }

        double atlag_jegybol(int[] t)
        {
            int szum = 0;
            for(int i=0; i<t.Length; i++)
            {
                if (t[i] != 0)
                {
                    szum += t[i];
                }
            }
            return Convert.ToDouble(szum)/t.Length;
        }

        double atlag_gyakorisagbol(int[] t)
        {
            double szum = 0;
            int db = 0;
            for(int i=1; i<t.Length;i++)
            {
                szum += i * t[i];
                db += t[i];
            }
            return szum / db;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int[] otos = lotto(5, 90, checkBox1.Checked);
            int[] hatos = lotto(6, 45);
            torol();
            kiir(otos);
        }

        int[] lotto(int db, int max, bool rendezve = true)
        {
            int[] lotto = new int[db];
            lotto[0] = randi.Next(max) + 1;
            int kovetkezo = 1;

            while(kovetkezo < db)
            {
                lotto[kovetkezo] = randi.Next(1,max+ 1);
                bool ism = false;
                for(int i=0; i<kovetkezo; i++)
                {
                    if (lotto[i] == lotto[kovetkezo]) ism = true;
                }
               if(!ism) kovetkezo++;
            }

            if(rendezve) Rendez(lotto);

            return lotto;
        }

        void Rendez(int[] tomb)
        {
            for (int i = 0; i < tomb.Length; i++)
                for (int j = 0; j < tomb.Length - 1 - i; j++)
                    if (tomb[j] > tomb[j + 1]) //ha az elöző nagyobb             
                        csere(ref tomb[j], ref tomb[j + 1]);
        }

        void csere(ref int a, ref int b )
        {
            int tmp = a;
            a = b;
            b = tmp;
        }

    }
}
